
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "halftone.h"


#define W 320
#define H 200

#define MW 320
#define MH 200

//extern unsigned char * texture;
unsigned char tmp[320*256];
//unsigned char * texture=NULL;
extern unsigned char texture[256*256];

int muunnos[MW*MH];

float sin_table[MW];
float cos_table[MH];

void init_tunneli() {
    int x,y,sx,sy;
    float z;
    float k;
    FILE * f;

    for (y=0; y<MH; y++)
	cos_table[y]=cos(y*0.01)*0.1;
    for (x=0; x<MW; x++)
	sin_table[x]=sin(x*0.1)*0.05;

    for (y=0; y<MH; y++)
	for (x=0; x<MW; x++) {

	    //z=1+sin(x*0.1)*0.05+(cos(y*0.01))*0.1;
	    z=1+sin_table[x]+cos_table[y];


	    if (z!=0) {
		sx=(float)(x-MW/2)/z+MW/2;
		sy=(float)(y-MH/2)/z+MH/2;
	    } else {
		sx=sy=0;
	    }
//	    sx+=k*2*256/(2*M_PI);

	    if (sy>255)
		sy-=256;

	    muunnos[y*MW+x]=
		(sy*256+sx);
	}


}
void tunneli(unsigned char * dst, int vbl, int threshold) {
    int x,y,sx,sy;
    float z;
    float k;
    FILE * f;
    int a;
    int xp;
    int yp;

    xp=(int)(vbl*2) % 256;
    yp=(int)(sin(vbl*0.01)*100+100) % 256;

    if (threshold)  {

	for (y=0; y<H; y++) {
	    for (x=0; x<W; x++) {
		a=texture[18+(yp*256+xp+muunnos[y*MW+x]) % (256*256)];
                if (a>threshold)
		    dst[y*W+x]=150;
                else
		    dst[y*W+x]=0;
	    }
	}


    } else {

	for (y=0; y<H; y++) {
	    for (x=0; x<W; x++) {
		dst[y*W+x]=texture[18+(yp*256+xp+muunnos[y*MW+x]) % (256*256)];
	    }
	}


    }


}
